
(function(l, i, v, e) { v = l.createElement(i); v.async = 1; v.src = '//' + (location.host || 'localhost').split(':')[0] + ':35729/livereload.js?snipver=1'; e = l.getElementsByTagName(i)[0]; e.parentNode.insertBefore(v, e)})(document, 'script');
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('vue')) :
  typeof define === 'function' && define.amd ? define(['vue'], factory) :
  (global = global || self, global.VuePromiseBtn = factory(global.Vue));
}(this, function (Vue) { 'use strict';

  Vue = Vue && Vue.hasOwnProperty('default') ? Vue['default'] : Vue;

  //
  //
  //

  var script = {
    name: 'Spinner',
    props: {
      color: {
        type: String,
        default: '#3498db'
      },
      size: {
        type: Number,
        default: 18
      },
      width: {
        type: Number,
        default: 4
      },
      duration: {
        type: String,
        default: '1s'
      }
    },
    computed: {
      style: function style () {
        return {
          borderTopColor: this.color,
          width: ((this.size) + "px"),
          height: ((this.size) + "px"),
          borderWidth: ((this.width) + "px"),
          animationDuration: this.duration
        }
      }
    }
  };

  function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier
  /* server only */
  , shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
      createInjectorSSR = createInjector;
      createInjector = shadowMode;
      shadowMode = false;
    } // Vue.extend constructor export interop.


    var options = typeof script === 'function' ? script.options : script; // render functions

    if (template && template.render) {
      options.render = template.render;
      options.staticRenderFns = template.staticRenderFns;
      options._compiled = true; // functional template

      if (isFunctionalTemplate) {
        options.functional = true;
      }
    } // scopedId


    if (scopeId) {
      options._scopeId = scopeId;
    }

    var hook;

    if (moduleIdentifier) {
      // server build
      hook = function hook(context) {
        // 2.3 injection
        context = context || // cached call
        this.$vnode && this.$vnode.ssrContext || // stateful
        this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext; // functional
        // 2.2 with runInNewContext: true

        if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
          context = __VUE_SSR_CONTEXT__;
        } // inject component styles


        if (style) {
          style.call(this, createInjectorSSR(context));
        } // register component module identifier for async chunk inference


        if (context && context._registeredComponents) {
          context._registeredComponents.add(moduleIdentifier);
        }
      }; // used by ssr in case component is cached and beforeCreate
      // never gets called


      options._ssrRegister = hook;
    } else if (style) {
      hook = shadowMode ? function () {
        style.call(this, createInjectorShadow(this.$root.$options.shadowRoot));
      } : function (context) {
        style.call(this, createInjector(context));
      };
    }

    if (hook) {
      if (options.functional) {
        // register for functional component in vue file
        var originalRender = options.render;

        options.render = function renderWithStyleInjection(h, context) {
          hook.call(context);
          return originalRender(h, context);
        };
      } else {
        // inject component registration as beforeCreate hook
        var existing = options.beforeCreate;
        options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
      }
    }

    return script;
  }

  var normalizeComponent_1 = normalizeComponent;

  /* script */
  var __vue_script__ = script;
  /* template */
  var __vue_render__ = function() {
    var _vm = this;
    var _h = _vm.$createElement;
    var _c = _vm._self._c || _h;
    return _c("span", { staticClass: "spinner", style: _vm.style })
  };
  var __vue_staticRenderFns__ = [];
  __vue_render__._withStripped = true;

    /* style */
    var __vue_inject_styles__ = undefined;
    /* scoped */
    var __vue_scope_id__ = "data-v-8170247a";
    /* module identifier */
    var __vue_module_identifier__ = undefined;
    /* functional template */
    var __vue_is_functional_template__ = false;
    /* style inject */
    
    /* style inject SSR */
    

    
    var Spinner = normalizeComponent_1(
      { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
      __vue_inject_styles__,
      __vue_script__,
      __vue_scope_id__,
      __vue_is_functional_template__,
      __vue_module_identifier__,
      undefined,
      undefined
    );

  var isPromise = function (obj) {
    return !!obj && (typeof obj === 'object' || typeof obj === 'function') && typeof obj.then === 'function'
  };

  var isString = function (obj) {
    return typeof obj === 'string'
  };

  var isObject = function (obj) {
    return obj === Object(obj)
  };

  var pluginElPropName = '$promiseBtnId';
  var elementId = 0;

  var stringHTMLRenderer = function (options) {
    return ("\n  <span class=\"promise-btn__spinner-wrapper\" \n        :class=\"{[options.spinnerHiddenClass]: !show || false}\"\n        v-show=\"options.autoHideSpinnerWrapper ? show : true\"\n  >\n    " + (options.loader) + "\n  </span>")
  };

  var componentRenderer = function (options) {
    return function (h) {
      var obj;

      return h('span', {
        class: ( obj = {
          'promise-btn__spinner-wrapper': true
        }, obj[options.spinnerHiddenClass] = options.spinnerHiddenClass ? !this.show : false, obj ),
        directives: [{
          name: 'show',
          value: options.autoHideSpinnerWrapper ? this.show : true
        }]
      }, [
        h(options.loader)
      ])
    }
  };

  var initSpinner = function (btnEl, options, vnode, isLoaderString) {
    var dummyEl = document.createElement('SPAN');
    btnEl.appendChild(dummyEl);

    var vueSpinnerOptions = {
      el: dummyEl,
      data: { show: false },
      props: {
        parent: {
          type: Object,
          default: function () { return vnode.context; }
        }
      },
      render: options.componentRenderer(options)
    };

    if (isLoaderString) {
      var tpl = options.stringHTMLRenderer(options);
      var res = Vue.compile(tpl);
      vueSpinnerOptions = Object.assign({}, vueSpinnerOptions,
        {data: Object.assign({}, vueSpinnerOptions.data,
          {options: options}),
        render: res.render,
        staticRenderFns: res.staticRenderFns});
    }

    return vueSpinnerOptions
  };

  var enableBtn = function (el, options) {
    if (el.getAttribute('disabled') && options.disableBtn) { el.removeAttribute('disabled'); }
    el.classList.remove(options.btnLoadingClass);
  };

  var disableBtn = function (el, options) {
    if (options.disableBtn) { el.setAttribute('disabled', 'disabled'); }
    el.classList.add(options.btnLoadingClass);
  };

  var setupVuePromiseBtn = function (globalOptions) {
    var directive = {
      listeners: {},
      init: function init (el, binding, vnode) {
        var isBindingValueObj = isObject(binding.value);
        var id = el[pluginElPropName] = elementId++;
        var instanceOptions = isBindingValueObj ? binding.value : {};
        var options = Object.assign({}, globalOptions,
          instanceOptions);
        var isLoaderString = isString(options.loader);
        var btnEl = el;
        var spinnerVM = null;
        var minTimeoutDone = false;
        var promiseDone = false;
        var scheduled = false;

        // START: loading state handlers
        var handleLoadingFinished = function (btnEl) {
          if (minTimeoutDone && promiseDone) {
            spinnerVM.show = false;
            minTimeoutDone = false;
            promiseDone = false;
            enableBtn(btnEl, options);
          }
        };

        var initLoading = function (btnEl) {
          scheduled = true;
          disableBtn(btnEl, options);
          if (options.showSpinner) {
            spinnerVM.show = true;
            setTimeout(function () {
              minTimeoutDone = true;
              handleLoadingFinished(btnEl);
            }, options.minTimeout);
          }
        };

        var finishLoading = function () {
          scheduled = false;
          if (options.showSpinner) {
            promiseDone = true;
            handleLoadingFinished(btnEl);
          }
        };

        var getFiniteHandler = function (expression) {
          var result = expression;
          while (typeof result === 'function') {
            result = result();
          }
          return result
        };

        var promiseHanlder = function (btnEl, promise) {
          initLoading(btnEl);
          return promise
            .then(function () { return finishLoading(btnEl); })
            .catch(function (e) {
              finishLoading(btnEl);
              throw e
            })
        };
        // END: loading state handlers

        // Bind individual params to directive
        directive.listeners[id] = {
          el: el,
          eventType: options.action
        };

        // Setup button element if directive defined on form element
        if (options.action === 'submit') {
          btnEl = el.querySelector('[type="submit"]');
          if (!btnEl) { throw new Error('No submit button found') }
        }

        // Setup option to show/hide spinner
        if (options.showSpinner) {
          var vueSpinnerOptions = initSpinner(btnEl, options, vnode, isLoaderString);
          spinnerVM = new Vue(vueSpinnerOptions);
        }

        // Finish initialization for Extended Mode (if we want use external promise from model)
        if (options.hasOwnProperty('promise')) {
          directive.listeners[id].promiseHanlder = promiseHanlder;
          return
        }

        // Continue initialization for simplified usage mode
        // Extract default event listener internally generated by Vue
        // _withTask - legacy method for Vue < 2.6, _wrapper - for Vue >= 2.6
        var nativeEventHandler = vnode.data.on &&
            vnode.data.on[options.action] &&
            (vnode.data.on[options.action]._withTask || vnode.data.on[options.action]._wrapper);

        // Save nativeEventHandler in directive instance
        directive.listeners[id].nativeEventHandler = nativeEventHandler;

        // Remove native event listener
        el.removeEventListener(options.action, nativeEventHandler);

        if (!nativeEventHandler) { throw new Error('Please, provide proper handler/action for promise-btn') }

        // Set custom event that will replace original listener
        directive.listener = function (e) {
          if (options.disableBtn && scheduled) { return }
          var expression = nativeEventHandler(e);
          var handlerPromise = typeof expression === 'function' ? getFiniteHandler(expression) : expression;
          if (isPromise(handlerPromise)) {
            return promiseHanlder(btnEl, handlerPromise)
          }
        };
      },
      bind: function bind (el, binding, vnode) {
        var ref;

        // Init
        (ref = binding.def).init.apply(ref, arguments);

        // Replace native event listener
        var id = el[pluginElPropName];
        var ref$1 = directive.listeners[id];
        var eventType = ref$1.eventType;
        var promiseHanlder = ref$1.promiseHanlder;
        if (!promiseHanlder) {
          // Add event handler for simplified mode
          el.addEventListener(eventType, directive.listener);
        }
      },
      unbind: function unbind (el, binding) {
        // Cleanups if element removed to prevent memory leaks
        var id = el[pluginElPropName];
        var ref = directive.listeners[id];
        var eventType = ref.eventType;
        el.removeEventListener(eventType, directive.listener);
        delete directive.listeners[id];
        delete el[pluginElPropName];
      },
      componentUpdated: function componentUpdated (el, binding, vnode, oldVnode) {
        // Extended Mode trigger
        if (binding && binding.value &&
            binding.value.promise &&
            binding.value.promise !== binding.oldValue.promise
        ) {
          var id = el[pluginElPropName];
          var ref = directive.listeners[id];
          var promiseHanlder = ref.promiseHanlder;
          promiseHanlder(el, binding.value.promise);
        }
      }
    };
    return directive
  };

  var defaultOptions = {
    btnLoadingClass: 'loading',
    showSpinner: true,
    action: 'click',
    disableBtn: true,
    stringHTMLRenderer: stringHTMLRenderer,
    componentRenderer: componentRenderer,
    minTimeout: 400,
    spinnerHiddenClass: 'hidden',
    autoHideSpinnerWrapper: false,
    loader: Spinner
  };

  function install (Vue$$1, options) {
    var globalOptions = Object.assign({}, defaultOptions, options);
    Vue$$1.directive('promise-btn', setupVuePromiseBtn(globalOptions));
  }

  var main = {
    install: install,
    Spinner: Spinner,
    setupVuePromiseBtn: setupVuePromiseBtn
  };

  return main;

}));
